﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication23;
using SyncfusionMvcApplication23.Grid;
using Syncfusion.JavaScript.Models;
using System.Collections;
using System.Web.Script.Serialization;
using Syncfusion.XlsIO;
using Syncfusion.EJ.Export;
using System.Reflection;
using Syncfusion.JavaScript;
using System.Drawing;
namespace SyncfusionMvcApplication23.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            var DataSource = new NorthwindDataContext().OrdersViews.Take(30).ToList();
            ViewBag.datasource = DataSource;
            return View();
        }
        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = new NorthwindDataContext().OrdersViews.Take(30).ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "none");
        }
        public void ExportToWord(string GridModel)
        {
            WordExport exp = new WordExport();
            var DataSource = new NorthwindDataContext().OrdersViews.Take(30).ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.docx", false, false, "none");
        }
        public void ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            var DataSource = new NorthwindDataContext().OrdersViews.Take(30).ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.pdf", false, false, "none");
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            AutoFormat auto = new AutoFormat();

            auto.FontFamily = "Arial";

            auto.ContentBorderColor = Color.Brown;

            auto.ContentFontSize = 10;

            auto.GCaptionBorderColor = Color.Cornsilk;

            auto.GContentFontColor = Color.DarkBlue;

            auto.HeaderFontSize = 12;

            auto.HeaderBorderColor = Color.Red;

            auto.ContentBgColor = Color.Wheat;

            auto.GHeaderBgColor = Color.Crimson;

            auto.AltRowBgColor = Color.LightCyan;

            gridProp.AutoFormat = auto;

            return gridProp;
        }

    }
}